Index: SPECS/gcc41.spec
===================================================================
--- SPECS.orig/gcc41.spec
+++ SPECS/gcc41.spec
@@ -9,8 +9,13 @@
 %else
 %define build_ada 0
 %endif
+%ifnarch %{arm}
 %define build_java 1
 %define build_objc 1
+%else
+%define build_java 0
+%define build_objc 0
+%endif
 %ifarch s390x
 %define multilib_32_arch s390
 %endif
@@ -26,7 +31,7 @@
 Summary: Various compilers (C, C++, Objective-C, Java, ...)
 Name: gcc
 Version: %{gcc_version}
-Release: %{gcc_release}
+Release: %{gcc_release}.fa1
 License: GPL
 Group: Development/Languages
 Source0: gcc-%{version}-%{DATE}.tar.bz2
@@ -41,7 +46,8 @@ BuildRoot: %{_tmppath}/%{name}-%{version
 # Need binutils which support .weakref >= 2.16.91.0.3-1
 # Need binutils which support --hash-style=gnu >= 2.17.50.0.2-7
 # Need binutils which support mffgpr and mftgpr >= 2.17.50.0.2-8
-BuildRequires: binutils >= 2.17.50.0.2-8
+# Need binutils which support 2-argument .movsp >= 2.17.50.0.5
+BuildRequires: binutils >= 2.17.50.0.5
 BuildRequires: zlib-devel, gettext, dejagnu, bison, flex, texinfo, sharutils
 %if %{build_java}
 BuildRequires: gcc-java, libgcj, /usr/share/java/eclipse-ecj.jar, zip, unzip
@@ -76,7 +82,8 @@ Requires: cpp = %{version}-%{release}
 # Need binutils that support .weakref
 # Need binutils that supports --hash-style=gnu
 # Need binutils that support mffgpr/mftgpr
-Requires: binutils >= 2.17.50.0.2-8
+# Need binutils that support 2-argument .movsp >= 2.17.50.0.5
+Requires: binutils >= 2.17.50.0.5
 # Make sure gdb will understand DW_FORM_strp
 Conflicts: gdb < 5.1-2
 Requires: glibc-devel >= 2.2.90-12
@@ -136,8 +143,15 @@ Patch23: gcc41-pr28690.patch
 Patch24: gcc41-pr32468.patch
 Patch25: gcc41-pr32468-2.patch
 Patch26: gcc41-rh245424.patch
-
+Patch27: gcc41-pr28516.patch
+Patch28: gcc41-pr30384.patch
+Patch29: gcc41-armeabi-floatundi-redefine.patch
+
+# On ARM EABI systems, we do want -gnueabi to be part of the
+# target triple.
+%ifnarch %{arm}
 %define _gnu %{nil}
+%endif
 %ifarch sparc
 %define gcc_target_platform sparc64-%{_vendor}-%{_target_os}
 %endif
@@ -441,6 +455,9 @@ which are required to run programs compi
 %patch24 -p0 -b .pr32468~
 %patch25 -p0 -b .pr32468-2~
 %patch26 -p0 -b .rh245424~
+%patch27 -p0 -b .pr28516~
+%patch28 -p0 -b .pr30384~
+%patch29 -p0 -b .floatundi~
 
 sed -i -e 's/4\.1\.3/4.1.2/' gcc/BASE-VER gcc/version.c
 sed -i -e 's/" (Red Hat[^)]*)"/" (Red Hat %{version}-%{gcc_release})"/' gcc/version.c
